//+------------------------------------------------------------------+
//|                                            Cronex Impulse CD.mq4 |
//|                                        Copyright  2007, Cronex. |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2008, Cronex"
#property  link      ""
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  SteelBlue
#property  indicator_color2  DarkOrange
#property  indicator_color3  DarkOrange
//---- indicator parameters
extern int SlowMA=34;
extern int FastMA=14;
extern int SignalMA=9;
//---- indicator buffers

double     MacdDivrBuffer[];
double     SignalBuffer[];
double     CDDivrBuffer[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorDigits(5);
      SetIndexBuffer(0,MacdDivrBuffer);  SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"Impulse MACD");
      SetIndexBuffer(1,SignalBuffer);    SetIndexStyle(1,DRAW_LINE);      SetIndexLabel(1,"Signal");
      SetIndexBuffer(2,CDDivrBuffer);    SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"Impulse CD");   
   IndicatorShortName("Cronex Impulse CD("+SlowMA+","+FastMA+","+SignalMA+")");
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
          int limit=MathMax(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
     double HiInd     = iMA(NULL,0,SlowMA,0,MODE_SMMA,PRICE_HIGH    ,i);
     double LoInd     = iMA(NULL,0,SlowMA,0,MODE_SMMA,PRICE_LOW     ,i);
     double MasterInd = iMA(NULL,0,FastMA,0,MODE_LWMA,PRICE_WEIGHTED,i);

      MacdDivrBuffer[i] = 0;
         if(MasterInd>HiInd) MacdDivrBuffer[i]=MasterInd-HiInd;
         if(MasterInd<LoInd) MacdDivrBuffer[i]=MasterInd-LoInd;  
   }
   for(i=limit; i>=0; i--)
   {
       SignalBuffer[i] = iMAOnArray(MacdDivrBuffer,Bars,SignalMA,0,MODE_SMA,i);
       CDDivrBuffer[i] = MacdDivrBuffer[i]-SignalBuffer[i];       
   }       
   return(0);
}